public class Reines {

    private int n; // le nombre de reines a placer (n >= 1).
    private EchiquierDeReines edr; // l'chiquier commun

    public Reines(int nombreDeReines) {
        n = nombreDeReines;
    }

    // Retourne une solution, si elle existe, au problme des reines sur
    // un chiquier de taille n.
    //
    public String uneSolution() {
        <A COMPLETER>
    }

    // mthode rcursive associe  uneSolution()
    //
    private boolean uneSolution(int l) {
        <A COMPLETER>
    }

    // Retourne toutes les solutions au problme des reines sur
    // un chiquier de taille n.
    //
    public Vector toutesLesSolutions() {
        <A COMPLETER>
    }

    // mthode rcursive associe  toutesLesSolutions()
    //
    private void toutesLesSolutions(int l, Vector lesSolutions) {
        <A COMPLETER>
    }
}

// Une classe pour abstraire un chiquier ne contenant que des reines libres
// (c'est  dire qui ne sont pas en prise les unes avec les autres). Pour
// un chiquier  n cases, les lignes, les colonnes et les reines sont num-
// rotes de 0  n - 1. La reine de numro i est obligatoirement dans la colonne
// numro i. Si k reines sont sur l'chiquier, se sont les reines 0  k-1.
//
public class EchiquierDeReines {

    <ATTRIBUTS : A COMPLETER>

    // Construit un chiquier de reines vide (ne contenant aucune reine).
    // Paramtre n : la taille de l'chiquier et le nombre de reines  placer.
    // Prcondition : n >= 1. Complexit : O(1).
    //
    public EchiquierDeReines(int n) {
        <A COMPLETER>
    }

    // Teste si l'chiquier est plein (s'il contient n reines libres,
    // o n est la taille de l'chiquier).
    // Valeur rendue : true si l'chiquier contient n reines libres.
    // Complexit : O(1).
    //
    public boolean plein() {
        <A COMPLETER>
    }

    // Teste si l'chiquier est vide (s'il ne contient aucune reine).
    // Valeur rendue : true si l'chiquier est vide.
    // Complexit : O(1).
    //
    public boolean vide() {
        <A COMPLETER>
    }

    // Teste si une nouvelle reine place en ligne l sur la premire colonne
    // libre est en prise avec les reines dj places sur l'chiquier.
    // Paramtre l : un numro de ligne.
    // Prcondition : 0 <= l < n, l'chiquier contient les k reines libres
    // 0, 1, .., k-1 et k < n.
    // Valeur rendue : true si, place en ligne l et en colonne k, la reine
    // k est en prise avec d'autres reines dj sur l'chiquier.
    // Complexit : O(1).
    //
    public boolean enPrise(int l) {
        <A COMPLETER>
    }

    // Ajoute une nouvelle reine libre  l'chiquier.
    // Paramtre l : un numro de ligne.
    // Prcondition : 0 <= l < n et enPrise(l) est false.
    // Postrelation : si l'chiquier contenait k reines, il contient
    // maintenant une k+1 ime reine libre en ligne l et en colonne k.
    // Complexit : O(1).
    //
    public void ajouterNouvelleReine(int l) {
        <A COMPLETER>
    }

    // Enlve la dernire reine qui a t place sur l'chiquier.
    // Prcondition : l'chiquier n'est pas vide et contient les k reines
    // libres 0, 1, .., k-1 avec 1 <= k <= n.
    // Postrelation : si k > 1, l'chiquier contient les k-1 reines libres
    // 0, 1, .., k-2 sinon l'chiquier est vide.
    // Complexit : O(1).
    //
    public void enleverDerniereReine() {
        <A COMPLETER>
    }

    // Retourne le numro de la ligne de la dernire reine qui a t
    // place sur l'chiquier.
    // Prcondition : l'chiquier n'est pas vide et contient les k reines
    // libres 0, 1, .., k-1 avec 1 <= k <= n.
    // Valeur rendue : le numro de ligne de la reine k-1.
    // Complexit : O(1).
    //
    public int derniereLigne() {
        <A COMPLETER>
    }

    // Construit une chane de caractres reprsentant l'chiquier.
    // Valeur rendue : une chane de caractres reprsentant l'chiquier.
    // Complexit : O(k) o k est le nombre de reines places sur l'chiquier.
    //
    public String toString() {
        <A COMPLETER>
    }
    // Une classe pour un objet qui garde les informations pertinentes
    // concernant l'occupation des lignes, colonnes et diagonales de
    // l'chiquier. Les lignes et les colonnes sont numrotes de 0  n-1.
    //
    private class GestionOccupationEchiquier {
	
	<ATTRIBUTS : A COMPLETER>
	    
	// Construit un objet correspondant  un chiquier vide.
	// Paramtre n : la taille de l'chiquier.
	// Prcondition : n >= 1.
	// Complexit : O(1).
	//
	public GestionOccupationEchiquier(int n) {
	    <A COMPLETER>
		 }
	
	// Retourne la taille de l'chiquier.
	// Complexit : O(1).
	//
	public int taille() {
	    <A COMPLETER>
		 }
	
	// Teste si on peut ajouter une reine libre  une position donne.
	// Paramtre l : la ligne o on dsire ajouter la reine.
	// Paramtre c : la colonne o on dsire ajouter la reine.
	// Prcondition : 0 <= l < n et 0 <= c < n (n = taille de l'chiquier).
	// Valeur rendue : true si une nouvelle reine place en ligne l et en
	// colonne c est en prise avec d'autres reines dj places sur
	// l'chiquier.
	// Complexit : O(1).
	//
	public boolean enPrise(int l, int c) {
	    <A COMPLETER>
		 }
	
	// Paramtre l : la ligne o on dsire ajouter la reine.
	// Paramtre c : la colonne o on dsire ajouter la reine.
	// Prcondition : 0 <= l < n et 0 <= c < n (n = taille de l'chiquier),
	//                enPrise(l, c) est false.
	// Postrelation : Met  jour l'occupation aprs l'ajout d'une reine 
	//  une position donne (l, c).
	// Complexit : O(1).
	//
	public void ajouter(int l, int c) {
	    <A COMPLETER>
		 }
	
	// Paramtre l : la ligne o on dsire ajouter la reine.
	// Paramtre c : la colonne o on dsire ajouter la reine.
	// Prcondition : 0 <= l < n et 0 <= c < n (n = taille de l'chiquier),
	//                enPrise(l, c) est false.
	// Postrelation : Met  jour l'occupation aprs le retrait d'une reine 
	//  une position donne (l, c).
	// Complexit : O(1).
	//
	public void enlever(int l, int c) {
	    <A COMPLETER>
		 }
    }
}
